addpath('images','def_Functions')
ImagePath = 'opo9828c_512_512.jpg'

bw=8
Lx=bw;
Ly=bw;
wavelet=1
pss= 45.35

[mImage, sInfo, map] = LoadImage(ImagePath); %load the image 
[mI2Orig, bitDepth]= MImage2Grey(mImage, sInfo, map); %convert it to Grey

a=2;
DDx=DCos(Lx,a*Lx,a);
DDy=DCos(Ly,a*Ly,a);
DDx=NormDict(DDx);
DDy=NormDict(DDy);
get_dict_ShabW %(load dicationary Dsx and Dsy)
Dx=[DDx Dsx];
Dy=[DDy Dsy];
MaxInt = max(max(mI2Orig)) %255 

if wavelet ==1
    wlevel=5;
    mI = waveletcdf97(mI2Orig, wlevel);%transform to wavelet domain
else
    mI=mI2Orig; 
end

tol=MaxInt^2/(10^(pss/10))
z=size(mI2Orig);
delta=1;
tolMacro = tol*z(1)*z(2) *(1/delta)
MaxNum = numel(mI2Orig); %floor(numel(mI)/ChosenSR)
B = mat2cell(mI,Lx*ones(1,(z(1)/Lx)), Ly*ones(1,(z(2)/Ly)));
No=MaxNum;

% #Start Process
ProcessLargeAllTime = tic
%[h,Di1,Di2,beta,c,Q,Nat] = HBW_OMP2D_Mex(B,Dx,Dy,tolMacro,No); %Approx using pss
[h,Di1,Di2,beta,c,Q,Nat] = HBW_OMP2D_Mex(B,Dx,Dy,0,5972); % Approx using fixed NAT

% #Stop Time 
Time= toc(ProcessLargeAllTime);
Time
Time60=Time/60
mImage=cell2mat(h);

if wavelet == 1; 
    mImage=waveletcdf97(mImage,-wlevel);%get back to the pixel domain
end

% #Outputs
PSNR = CalcPSNR2(mI2Orig,mImage,255) % PSNR of the approximation
ssim_ind = ssim_index(mI2Orig,mImage) %ADDED info, if mImage=mI2, then ssim_ind=1
SR = numel(mI2Orig)/Nat % Sparsity ratio